package org.apache.jmeter.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

import org.apache.jmeter.util.JMeterUtils;

/**
 * Title:        Apache JMeter
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Apache Foundation
 * @author Michael Stover
 * @version 1.0
 */

public class ButtonPanel extends JPanel
{

	public static final int ADD_BUTTON = 1;
	public static final int EDIT_BUTTON = 2;
	public static final int DELETE_BUTTON = 3;
	public static final int LOAD_BUTTON = 4;
	public static final int SAVE_BUTTON = 5;

	private JButton add, delete, edit, load,save;

	public ButtonPanel()
	{
		init();
	}

	private void initButtonMap()
	{
	}

	private void init()
	{
		add = new JButton(JMeterUtils.getResString("add"));
		add.setActionCommand("Add");
		edit = new JButton(JMeterUtils.getResString("edit"));
		edit.setActionCommand("Edit");
		delete = new JButton(JMeterUtils.getResString("delete"));
		delete.setActionCommand("Delete");
		load = new JButton(JMeterUtils.getResString("load"));
		load.setActionCommand("Load");
		save = new JButton(JMeterUtils.getResString("save"));
		save.setActionCommand("Save");
		Dimension d = delete.getPreferredSize();
		add.setPreferredSize(d);
		edit.setPreferredSize(d);
		//close.setPreferredSize(d);
		load.setPreferredSize(d);
		save.setPreferredSize(d);
		GridBagLayout g = new GridBagLayout();
		this.setLayout(g);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = c.NONE;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.gridx = 1;
		c.gridy = 1;
		g.setConstraints(add, c);
		this.add(add);
		c.gridx = 2;
		c.gridy = 1;
		g.setConstraints(edit, c);
		this.add(edit);
		c.gridx = 3;
		c.gridy = 1;
		g.setConstraints(delete, c);
		this.add(delete);
		/*
		 * c.gridx = 1;
		 * c.gridy = 2;
		 * g.setConstraints(close, c);
		 * panel.add(close);
		 */
		c.gridx = 2;
		c.gridy = 2;
		g.setConstraints(load, c);
		this.add(load);
		c.gridx = 3;
		c.gridy = 2;
		g.setConstraints(save, c);
		this.add(save);
	}

	public void addButtonListener(int button,ActionListener listener)
	{
		switch(button)
		{
			case ADD_BUTTON : add.addActionListener(listener);break;
			case EDIT_BUTTON : edit.addActionListener(listener);break;
			case DELETE_BUTTON : delete.addActionListener(listener);break;
			case LOAD_BUTTON : load.addActionListener(listener);break;
			case SAVE_BUTTON : save.addActionListener(listener);break;
		}
	}
}